;    This file is part of hb, halfband-led-spectrumanalyzer
;
;    hb is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    hb is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with hb.  If not, see <http://www.gnu.org/licenses/>.

;-----------------------------------------------------------------------------


; one filterstruct is made of 
; * an array for the samples; currently 15 bytes
; * maybe unused space
; * 3 byte square sum
; * 1 byte bardot counter: determins the amount of time passing by until
;                          the dot starts to move down and its speed.
; * 1 byte bar/dot status: upper nibble -> which one of the dots will be lit
;                          lower nibble -> how long will the bar be lit.
;   example 0x94 : dot#9  and 4 LEDs of the bar will be lit in this column
; 


.set fsize , 20 ; size of the filterstruct
.set bdso , fsize - 1 ; bar/dotstatus offset
.set bdco , fsize - 2 ; bar/dotcounter offset
.set sqso , fsize - 5 ; square sum offset
