/*
;    This file is part of hb, halfband-led-spectrumanalyzer
;
;    hb is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    hb is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with hb.  If not, see <http://www.gnu.org/licenses/>.
*/

/* compile with: 
    gcc -o geneeprom -O2 -Wall geneeprom.c
    (do not compile with avr-gcc)

 generate eeprom.hex:
    ./geneeprom
    avr-objcopy -I binary -O ihex eeprom.bin eeprom.hex
*/

#include <stdio.h>
#include <stdlib.h>
int main()
{
    FILE * fp;
    const unsigned char bardata[]={
         0x00,0x00,0x01,0x03,0x07,0x0f,0x1f,0x3f,
         0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff
    };
    const unsigned char dotdata[]={
         0x00,0x00,0x01,0x02,0x04,0x08,0x10,0x20,
         0x40,0x80,0x80,0x80,0x80,0x80,0x80,0x80
    };
    unsigned char brigitte;
    int bar,dot;

    fp=fopen("eeprom.bin","wb");
    if (fp==NULL) {
        perror("fopen:");
        exit(-1);
    }
    for (dot=0;dot<16;dot++) {
        brigitte = dotdata[dot];
        for (bar=0;bar<16;bar++) {
            brigitte |= bardata[bar];
            /* active low output: */
            fputc(~brigitte,fp);
        }
    }
    fclose(fp);
    return 0;
}
