;    This file is part of hb, halfband-led-spectrumanalyzer
;
;    hb is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    hb is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with hb.  If not, see <http://www.gnu.org/licenses/>.

;-----------------------------------------------------------------------------
.include "fstruct.inc"
;-----------------------------------------------------------------------------
.org 0x00
;--vector table ---------
reset:
    jmp main; reset vector
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
;-----------------
; ADC ready
    rjmp adc_irq;
    nop
;-----------------
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;
    jmp defaultInt;

;-----------------------------------------------------------------------------
defaultInt:
; tbd: led blink 2 indicate fault
; switch display off
; someone else may do this...
    reti;

;-----------------------------------------------------------------------------
; uses  r4 (column counter),r6, r25, r30, r31
;
adc_irq:
    in r6,0x3f   ; save flag register
    ldi r25,0x08 ;
    out 0x38,r25 ; int ack
    in r25,0x05  ; read adc
    ;--uncomment next line for testsignal sawtooth
    ;mov r25,r30
    ;--uncomment next line for testsignal silence
    ;ldi r25,0x80
    ;--end testsignal
    subi r25,128 ; convert to signed 8 bit
    ;--uncomment next line for -6dB 
    ;asr r25      ;  -6dB
    st z,r25     ; store in buffer
    inc r30      ; increment buffer write pointer
    mov r25,r30
    andi r25,0x0f;
    brne nodisplay

    push r28
    push r29;          save y
    push r18
    push r19           ;save working regs
    push r0
    push r1            ;save multiply result

    ldi r28,bdso 
    ldi r29,0x02       ; set y to start of rightmost bar

    in  r19,0x12       ; load status of port 
                       ; (where bit 7 is LSB LED; bit 0..3: ctrl of 7442

    mov  r18,r19       ; original status of port in r19
    andi r19,0x70      ; LSB LED is usually on; 
                       ;maybe we switch if off later; also lower nibble=0
    ori r18,0x0f;
    out 0x12,r18;      blank display
    mov r18,r4;        fetch old column counter
    subi r18,1
    brcc skip9
    ldi r18,9
skip9:    ;        advance to the next column
    mov r4,r18;        save actual column counter
    or r19,r18;      ; r19 ready to re-enable display with new column
    ldi r18,fsize
    mul r18,r4
    add r28,r0
    adc r29,r1       ; y=ptr to the bar/dotstatus

    ld r18,y         ; load ledstatus of new column
    andi r18,0x0f
    brne lsbledon
    ld r18,y      ; load ledstatus again
    andi r18,0xf0
    cpi  r18,0x10
    breq lsbledon
    ori r19,0x80;       LSB LED=off
lsbledon:
    ld r18,y      ; load ledstatus
    out 0x1e, r18; (EEARL) set up lookuptable
    sbi 0x1c,0x0 ; sbi eecr,eere
    in r18, 0x1d ; read lookuptable
    out 0x15,r18 ;     led 1..8 column data
    out 0x12,r19 ;     led 0 and new column data for the 7442

    pop r1       ;     restore things
    pop r0
    pop r19
    pop r18
    pop r29
    pop r28

nodisplay:
    out 0x3f,r6  ; restore flag register
    reti

